! Fourier transform and apply dip filter
program Dip_filter

use fourier

implicit none
complex, allocatable, dimension (:,:) :: data
integer n1, n2
integer hetch,putch

call initpar()
call doc('/homes/sep/claudio/sepwww/Lab5/Lab5/Dip_filter.rs')
  if (0>= hetch('n1','d',n1 )) then
    call erexit('Trouble reading  n1 from history  ')
  end if
  if (0>= hetch('n2','d',n2 )) then
    call erexit('Trouble reading  n2 from history  ')
  end if
allocate (data(n1,n2))
call dipfilt ( n1, n2, data )
end program Dip_filter

subroutine dipfilt ( n1, n2, data )

use fourier

implicit none

integer nw, nk, n1, n2, iw, ik, i3, n3,down
real dw, dk, d1, d2, w, k, w0, k0, vel, wt,wmax, wmin
complex data(n1,n2)
real angle,pi,angle0,ang
 

!########
! from param: SOME THAT YOU DECIDE ON
integer hetch,putch,auxputch,getch
  if (0>= hetch('n1','d',nw )) then
    call erexit('Trouble reading  n1 from history  ')
  end if
  if (0>= hetch('n2','d',nk )) then
    call erexit('Trouble reading  n2 from history  ')
  end if
  if (0>= hetch('n3','d',n3 )) then
    call erexit('Trouble reading  n3 from history  ')
  end if
  if (0>= hetch('d1','f',d1 )) then
    call erexit('Trouble reading  d1 from history  ')
  end if
  if (0>= hetch('d2','f',d2 )) then
    call erexit('Trouble reading  d2 from history  ')
  end if
  if (0.ne. auxputch('n1','d',n1 ,'fk_before')) then
    call erexit('Trouble writing  n1 to aux fk_before ')
  end if
  if (0.ne. auxputch('n2','d',n2 ,'fk_before')) then
    call erexit('Trouble writing  n2 to aux fk_before ')
  end if
  if (0.ne. auxputch('esize','d',8 ,'fk_before')) then
    call erexit('Trouble writing  esize to aux fk_before ')
  end if
  if (0>= hetch('d2','f',d2 )) then
    call erexit('Trouble reading  d2 from history  ')
  end if
  if (0.ne. auxputch('n1','d',n1 ,'fk_after')) then
    call erexit('Trouble writing  n1 to aux fk_after ')
  end if
  if (0.ne. auxputch('n2','d',n2 ,'fk_after')) then
    call erexit('Trouble writing  n2 to aux fk_after ')
  end if
  if (0.ne. auxputch('esize','d',8 ,'fk_after')) then
    call erexit('Trouble writing  esize to aux fk_after ')
  end if
dw = 1/((nw-1)*d1)
dk = 1/((nk-1)*d2)
w0 = -1/(2*d1)
k0 = -1/(2*d2)
  if (0.ne. auxputch('d1','f',dw ,'fk_before')) then
    call erexit('Trouble writing  d1 to aux fk_before ')
  end if
  if (0.ne. auxputch('d2','f',dk ,'fk_before')) then
    call erexit('Trouble writing  d2 to aux fk_before ')
  end if
  if (0.ne. auxputch('o1','f',w0 ,'fk_before')) then
    call erexit('Trouble writing  o1 to aux fk_before ')
  end if
  if (0.ne. auxputch('o2','f',k0 ,'fk_before')) then
    call erexit('Trouble writing  o2 to aux fk_before ')
  end if
  if (0.ne. auxputch('d1','f',dw ,'fk_after')) then
    call erexit('Trouble writing  d1 to aux fk_after ')
  end if
  if (0.ne. auxputch('d2','f',dk ,'fk_after')) then
    call erexit('Trouble writing  d2 to aux fk_after ')
  end if
  if (0.ne. auxputch('o1','f',w0 ,'fk_after')) then
    call erexit('Trouble writing  o1 to aux fk_after ')
  end if
  if (0.ne. auxputch('o2','f',k0 ,'fk_after')) then
    call erexit('Trouble writing  o2 to aux fk_after ')
  end if
!!parameter
 if (0>= getch('angle0','f',angle0 )) then
    call erexit('Trouble reading down from parameter ')
end if

 if (0>= getch('down','d',down )) then
    call erexit('Trouble reading down from parameter ')
end if
 if (0>= getch('wmax','f',wmax )) then
    call erexit('Trouble reading down from parameter ')
end if

 if (0>= getch('wmin','f',wmin )) then
    call erexit('Trouble reading down from parameter ')
end if


do i3=1,n3
  call sreed('in', data, n1*n2*8)
!########
! Un-comment and fix these 2 calls to FFT
!########
call ft1axis(0, 1.0, n1, n2, data)
call ft2axis(0, -1.0, n1, n2, data)

!#####
! Fix this so there is a dip filter, preferably with a taper
!#####

pi=2*acos(0.0)
!wmax=2.0
!wmin=1.0
vel=abs((w0+(abs(int(w0/dw)))*dw)/k0)! get the velocity by w/k=vel/sin(angle)
write (0,*) 'dw,dk,w0,k0,vel',dw,dk,w0,k0,vel
  call srite('fk_before',data,n1*n2*8)
  do iw = 1,n1
    w = (iw - 1) * dw + w0
    do ik = 1,n2
      k = (ik - 1) * dk + k0

     angle =asin(k/w*vel)*180.0/pi  !get the propagation angle: sin(angle)=vel*k/w

     ang=angle*down        ! if downgoing, down=1;else down=-1
    !write(0,*) "ang, angle, angle0",ang, angle, angle0
    !  if (ang>angle0) then
    !  wt = 1.0
    !  else if (ang<0) then
    !  wt=0.0
    ! else
    ! wt=sin(pi/2*ang/angle0)
    !  end if

      if (abs(w)>wmax) then
      wt = 1.0
      else if (abs(w)<wmin) then
      wt=0.0
     else
     wt=sin(pi/2*(w-wmin)/(wmax-wmin))
      end if
      data(iw,ik) = data(iw,ik)*wt
    end do
  end do
!########
! Un-comment and fix these 2 calls to inverse FFT
!########
  call srite('fk_after',data,n1*n2*8)
 call ft1axis(1, 1.0, n1, n2, data)
 call ft2axis(1, -1.0, n1, n2, data)
  call srite('out', data, n1*n2*8)
end do
return
end subroutine
