program MyPefDeSwell
use sep
use pef
use helicon
use wilson
implicit none
integer :: n1,n2,n123,i,niter,ierr,nlag,i2,i1,if,fw,nw,it,nlag1,nlag2,i12
real,dimension(:,:),pointer :: in2d,out2d,int
real, dimension(:),pointer :: in1d,out1d
type(filter) :: aa
  call sep_init()
  call from_history("n1",n1)
  call from_history("n2",n2)
  call from_param("niter",niter,100)
  call from_param("nlag1",nlag1)
  call from_param("nlag2",nlag2)
  n123=n1*n2
  nlag=nlag1*nlag2

  allocate(in2d(n1,n2),out2d(n1,n2))
  allocate(in1d(size(in2d)),out1d(size(in2d)))
  call sep_read(in2d)
  call allocatehelix(aa,nlag);
  in1d=reshape(in2d,(/size(in1d)/))
  allocate(aa%mis(n123))
  write(0,*) "allocation done"

  do i2=1, nlag2
    do i1=1, nlag1
      i12=i1+(i2-1)*nlag1
      aa%lag(i12)=i1+(i2-1)*n1+1
    end do
  end do


  call find_pef(in1d,aa,niter)
  write(0,*) "Pef",aa%flt
  write(0,*)
  call helicon_init(  aa)
  i=helicon_lop(.false.,.false.,in1d,out1d)
  out2d=reshape(out1d,(/n1,n2/))
  call sep_write(out2d)
  deallocate(in1d,out1d,in2d,out2d)
end program
