#!/bin/sh

###################################
### Dimg	 		###
###################################
### 1: iteration number  2: slop_neg
yisdir=/data/sep/yishen/WEMQA/dolphin
pbsdir=${yisdir}/PBS
bindir=${yisdir}/bin
datdir=${yisdir}
logdir=${yisdir}/log

bvel=${datdir}/dlp2D.bqiv.post.basc.bvel.iter${1}.H
bimg=${datdir}/dlp2D.iqtv.post.basc.bimg.iter${1}.H
dimg=${datdir}/dlp2D.iqtv.post.basc.dimg.iter${1}.H
slop=${datdir}/dlp2D.iqtv.post.basc.slop.iter${1}.H
rati=${datdir}/dlp2D.iqtv.post.basc.rati.iter${1}.H
spex=${datdir}/dlp2D.iqtv.post.basc.spex.iter${1}.H
slopsft=${datdir}/dlp2D.iqtv.post.basc.slopsft.iter${1}.H
pbsname=${pbsdir}/dlpDimg.pbs

	Transp<${bvel} plane=13|Window3d f3=110 n3=750 squeeze=n|Transp plane=13>junk.vel.H
	Window3d<${bimg} squeeze=n f3=110 n3=750| ~/bin/dimg_range.x vel=junk.vel.H slop_neg=y neigh=n nref=395 ver=n f_rang=0.03  nwin=70 lwin=50 nsmt_mx=5 nsmt_spex=3 rect_spex=2  nsmt_slop=1 rectx_slop=3 rectz_slop=3  rati=${rati} spex=${spex} slop=${slop} slopsft=${slopsft} |Pad beg3=110 n3out=1286|Window3d squeeze=n n5=400|Pad n5out=600>${dimg}







