#!/bin/sh


###################################
### Gradient processing		###
###################################
# 1: iteration number 

yisdir=/data/sep/yishen/WEMQA/dolphin
pbsdir=${yisdir}/PBS
bindir=${yisdir}/bin
datdir=${yisdir}
logdir=${yisdir}/log


grdo=${datdir}/dlp2D.iqtv.post.basc.grdo.iter${1}.H
grdp=${datdir}/dlp2D.iqtv.post.basc.grdp.iter${1}.H
mskw=${datdir}/dlp2D.mask.watb.z10.H
msks=${datdir}/dlp2D.mask.salt.z10.H
bvel=${datdir}/dlp2D.bqiv.post.basc.bvel.iter3.H
 

  cd ${yisdir}



if [ ${1} -eq 0 ];
then
	Smooth <${grdo} rect1=1>${grdp}
	${bindir}/myMPI-gradprcs.x grdo=${grdp} gmsk=${mskw} rectx_grd=10 recty_grd=5 rectz_grd=5 nsmt_grd=2 smtgrd=n smttyp="triflt" grdmsk=y gscale=n
	${bindir}/myMPI-gradprcs.x grdo=${grdp} gmsk=${msks} rectx_grd=2 recty_grd=1 rectz_grd=2 nsmt_grd=1 smtgrd=n smttyp="triflt" grdmsk=y gscale=n

else 
	Smooth <${grdo} rect1=1>${grdp}
	${bindir}/myMPI-gradprcs.x grdo=${grdp} gmsk=${mskw} rectx_grd=10 recty_grd=5 rectz_grd=5 nsmt_grd=2 smtgrd=n smttyp="triflt" grdmsk=y gscale=n
	${bindir}/myMPI-gradprcs.x grdo=${grdp} gmsk=${msks} rectx_grd=2 recty_grd=1 rectz_grd=2 nsmt_grd=1 smtgrd=n smttyp="triflt" grdmsk=y gscale=n
fi
  
