#!/bin/sh

###################################
### Line search 		###
###shLinsrcInv.sh ${iter} 
###################################
yisdir=/data/sep/yishen/WEMQA/dolphin
pbsdir=${yisdir}/PBS
bindir=${yisdir}/bin
datdir=${yisdir}
logdir=${yisdir}/log
shdir=/data/sep/yishen/WEMQA/dolphin/shScript/InversionQ_post_basic_2D
###################################
### search iteration 		###
###################################
P=${1}
O=$((${1}-1))
srch=${datdir}/dlp2D.iqtv.post.basc.srch.iter${O}.H
grdo=${datdir}/dlp2D.iqtv.post.basc.bq.iter${O}.H
grdp=${datdir}/dlp2D.iqtv.post.basc.bq.iter${P}.H
alfaO=${datdir}/dlp2D.iqtv.post.basc.alfa.iter${O}.H  
alfaP=${datdir}/dlp2D.iqtv.post.basc.alfa.iter${P}.H  
fobjO=${datdir}/dlp2D.iqtv.post.basc.fobj.iter${O}.H
fobjP=${datdir}/dlp2D.iqtv.post.basc.fobj.iter${P}.H
enda=${datdir}/dlp.end.X18I*.H
nsrch=2

  cd ${yisdir}
### 1: previous iteration; 2: current iteration

for isrch in {1..2} 
do
#rm -f ${pbsdir}/*.pbs
#  echo "Step length in ${isrch} of iteration ${2}"
#  # gradient processing: grdp=grdo+isrch*alpha*srch 
  <${grdo} ${bindir}/myMPI-srchprcs.x srch=${srch}  alpha=${alfaO} isrch=${isrch} qmin=1.6 qmax=3.699 >${grdp} 
# echo "<${grdo} ${bindir}/myMPI-srchprcs.x srch=${srch}  alpha=${alfaO} isrch=${isrch} qmin=1.301 qmax=3.699 >${grdp} (1.301=20/1.7=50)"

  # imaging 
  ${shdir}/shImgInv.sh ${1} ${P} 2 y

  # dimg, output fobj
  ${shdir}/shDimgLineInv.sh ${P} ${isrch}
done
   # Cat fobj 
   Cat ${datdir}/bpNPre.fobj.junk1.H ${datdir}/bpNPre.fobj.junk2.H axis=1>${datdir}/bpNPre.fobj.junka.H


# Make following into a code: input: fobj, alpha, bq2
  <${grdo} ${bindir}/myMPI-srchstep.x nsrch=${nsrch} alphO=${alfaO} alphP=${alfaP} fobjP=${datdir}/bpNPre.fobj.junka.H fobjO=${fobjO} fobj=${fobjP} srch=${srch} qmin=1.6 qmax=3.699>${grdp}

   #rm -f ${datdir}/bp.fobj.junk*.H
   #rm -f ${scrdir}/bp.fobj.junk*.H@




