program doit
use sep
use pef
use helicon
use wilson
implicit none
integer :: n1,n2,n123,i,niter,ierr,nlag,i2,i1,if,fw,nw,it
real,dimension(:,:),pointer :: in2d,out2d,int
real, dimension(:),pointer :: in,out,auto,inw
real :: a0,t0
integer :: nt
real,allocatable :: off(:)
type(filter) :: autoF,aa

call sep_init()
call from_history("n1",n1)
call from_history("n2",n2)
call from_param("fw",fw,500)
call from_param("nw",nw,500)
call from_param("niter",niter,100)
call from_param("t0",t0)
call from_param("nt",nt)
n123=n1*n2
allocate   (in2d(n1,n2),out2d(n1,n2),auto(0:100))
allocate(off(n2))
call from_param("nlag",nlag,25)


call sep_read(in2d)
call sep_read(off,"offset")
call allocatehelix(aa,nlag);
do i2=1,nlag
aa%lag(i2)=i2+3
end do

allocate(aa%mis(n123))
allocate(inw(nw))

allocate(int(nt,n2))
do i2=1,n2
   it=sqrt(t0*t0+off(i2)*off(i2)/1500/1500)
   int(:,n2)=in2d(it:it+nt-1,i2)
end do

allocate(in(size(int)))
in=reshape(int, (/size(in)/))
call find_pef(in,aa,niter)

deallocate(in)
allocate(in(size(in2d)),out(size(in2d)))
in=reshape(in2d,(/size(in)/))

  call helicon_init(  aa)
   i=helicon_lop(.false.,.false.,in,out)
  !call srite("pef.H",aa%flt,nlag*4)
call sep_write(out)





end program
